; Super Castlevania IV msu-1 patch by Conn
; $1120 track speicher
; $1122 msu busy flag

lorom


org $0280DD
jml playMsu

org $0081CA
jsl msuReady
nop

org $00857A
JSR $FED6

org $00FED6
JSL muteSPC
RTS

org $00A5AA
JML deathJingle
NOP

ORG $1ff500
playMsu:
AND #$00FE
TAY
PHA
LDA $2002      ;check if msu found
AND #$00FF 
CMP #$0053    
BEQ msuFound
PLA
JML $0280E1
msuFound:
PLA 
PHA
LSR
INC
STA $1120  ;store track number
STA $2004
STZ $2005
STZ $2006
LDA #$0002
STA $1122  ; set msu busy
PLA
JML $0283B3

msuReady:
LDA $1122 ; check msu ready flag
BNE $06
end:
LDA $4210
REP #$20
RTL
php
sep #$30
bit $2000
bvs endx    ; track not ready
DEC $1122  ; clear msu busy flag
LDA $1120
cmp #$1c
beq endx
cmp #$1e
beq endx
tax
lda #$FF   ; lautstrke
sta $2006
lda $1ff700,x ;load loop value
sta $2007  
endx:
plp
bra end

muteSPC:
PHA
LDA $2002      ;check if msu found
CMP #$53
BEQ mute
PLA
STA $2140
REP #$30
RTL 
mute:
PLA



cmp #$A6 ; mute when dying
BNE $09
STA $2140
STZ $2007
REP #$30
RTL
CMP #$F0  ;mute spc when pressing Start/Pause
BNE $09
STA $2140
STZ $2007
REP #$30
RTL
CMP #$FC  ;mute when intro
BNE $09
STA $2140
STZ $2007
REP #$30
RTL
CMP #$F1 ; resume spc when pressing Start/play
BNE next
LDA $1120 ; load track number
TAX
lda $1ff700,x ;load loop value
sta $2007  
lda #$FF
sta $2006
LDA #$F1 
STA $2140
REP #$30
RTL
next:
CMP #$A0 ; resume spc when pressing Start/play
BNE next1
LDA $1120 ; load track number
TAX
lda $1ff700,x ;load loop value
sta $2007   
lda #$FF
sta $2006
LDA #$A0 
STA $2140
REP #$30
RTL
next1:
CMP #$9c ; resume spc when pressing Start/play
BNE next2
LDA $1120 ; load track number
cmp #$1c
beq $04
cmp #$1e
BNE noOrb
TAX
lda $1ff700,x ;load loop value
sta $2007   
lda #$FF
sta $2006
noOrb:
LDA #$9c 
STA $2140
REP #$30
RTL
next2:
CMP #$FE
BNE $09
lda $70
bne $03
stz $2007
lda #$fe
STA $2140
REP #$30
RTL

deathJingle:
STZ $6a
LDA $2002      ;check if msu found
AND #$00FF 
CMP #$0053    
BEQ msuDeathJingle
LDA #$00A6
JML $00A5AF
msuDeathJingle:
PHP
SEP #$20
LDA #$80
STA $2004
STZ $2005
STZ $2006
loopDeath:
lda $2000
AND #$40
BNE loopDeath
lda $2000
AND #$08
BNE playspc ; error bit set?
LDA #$ff
STA $2006
LDA #$01
STA $2007

PLP
JML $00A5B3
playspc:
PLP
LDA #$00A6
JML $00A5AF

ORG $1ff700 ; loop table 03:loop, 01 non-loop
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 00-0f
db $03,$03,$03,$03,$03,$03,$03,$01,$01,$03,$03,$03,$01,$03,$03,$03 ; themes 10-1f
db $01,$01,$03,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01 ; themes 20-2f
